Notes for solving some of the 5G-AKA component compromise lemmas in Tamarin
===

These are meant as general hints and guidelines, rather than hard and fast rules.
The main results (non-component compromise) can all be proven automatically.

Where numbers are presented, this is the number of the goal to prove. Pressing this number on the keyboard also works.

How to solve some of the agreement lemmas.
---
This works for e.g. "all SEAFs compromised, POV of SEAF lemmas"
Use `S` as the base heuristic. Note this is different to `s`.

* Choose the first option (1, 1, 1) until it branches a bit.
* Then when you get the option, choose to solve for `!KU(FX(<...>))`, then solve for `!KU(~K)` as soon as it comes up, or go via `!KU(f2), f3, f4`, then `!KU(~K)`.
* Then hit auto (`A`) / `1` until it moves into next section.
* Then when that terminates (quickly hopefully), choose `!KU(FX(<...>))` when it comes up (i.e. repeat above), otherwise hit 1 until it comes up.

Never choose `!KU(f1(...))`, or anything that branches beyond a very small amount. Don't bother with `!KU( RAND )` or `( ~sqn )`.

Same rough outline for when AUSF is compromised, but in this case leads to compromises.
* Prioritise `AUSF_State_ID` or `SEAF_State_ID`, or `~RAND` (or anything else fresh if nothing better presents itself, perhaps not `~sqn` though). 
* Avoid anything that causes branches.

* One useful path -- take a bunch of `F_RcvS(...)`s, but as soon as an `AUSF_State_ID` or `SEAF_State_ID` shows up, grab that first. Always grab the `KU(FX(...))` when it turns up though, as this is `K_SEAF`.

* Where nothing better presents itself, pick the `AUSF_State_ID` or `SEAF_State_ID` furthest up the list.

Component compromise (Not-My-X) strategy:
---
* Simplify, Commit, `St_2_UE`, `UESQN`, `!KU(f1(...))`. 
* Work through until violation or proof found.

* Always pick the `KDFA` / `FX` / thing that invokes `!KU( ~K )` as then it kills branches very quickly.

All (SEAF) Compromise apart from mine (Not-My-SEAF):
---
* `S heuristic, then: 1 1 1 1 6 (KDFA/FX) 6 (f2/3/4) 6 (~K) a a 5 5 5 a a 8 8 7 a a Done.`


How to find attacks:
---
* Works well for e.g. All SEAFs/AUSFs compromised apart from mine: (i.e. goals to pick)
* `Commit - St_2 - UESQN - !KU(~sqn) - F_RcvS (1) - ARPFEntry - !KU(~SUPI.1) - !KU(f1(~K...)) --> select comp_receive_case_2 --> Auto a --> attack` Done.
